Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::ManualObject Class Reference

Class providing a much simplified interface to generating manual objects with custom geometry. More...

`#include <OgreManualObject.h>`

Inheritance diagram for Ogre::ManualObject:

[legend]
List of all members.

## Public Types
typedef std::vector< ManualObjectSection * > | SectionList
typedef std::vector< ShadowRenderable * > | ShadowRenderableList
typedef VectorIterator< ShadowRenderableList > | ShadowRenderableListIterator
## Public Member Functions
| ManualObject (const String &name)
virtual | ~ManualObject ()
virtual void | clear (void)
| Completely clear the contents of the object.
virtual void | estimateVertexCount (size_t vcount)
| Estimate the number of vertices ahead of time.
virtual void | estimateIndexCount (size_t icount)
| Estimate the number of indices ahead of time.
virtual void | begin (const String &materialName, RenderOperation::OperationType opType=RenderOperation::OT_TRIANGLE_LIST)
| Start defining a part of the object.
virtual void | setDynamic (bool dyn)
| Use before defining gometry to indicate that you intend to update the geometry regularly and want the internal structure to reflect that.
virtual bool | getDynamic () const
| Gets whether this object is marked as dynamic.
virtual void | beginUpdate (size_t sectionIndex)
| Start the definition of an update to a part of the object.
virtual void | position (const Vector3 &pos)
| Add a vertex position, starting a new vertex at the same time.
virtual void | position (Real x, Real y, Real z)
| Remarks: A vertex position is slightly special among the other vertex data methods like normal() and textureCoord(), since calling it indicates the start of a new vertex. All other vertex data methods you call after this are assumed to be adding more information (like normals or texture coordinates) to the last vertex started with position().
virtual void | normal (const Vector3 &norm)
| Add a vertex normal to the current vertex.
virtual void | normal (Real x, Real y, Real z)
| Remarks: Vertex normals are most often used for dynamic lighting, and their components should be normalised.
virtual void | textureCoord (Real u)
| Add a texture coordinate to the current vertex.
virtual void | textureCoord (Real u, Real v)
| Remarks: You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.
virtual void | textureCoord (Real u, Real v, Real w)
| Remarks: You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.
virtual void | textureCoord (const Vector2 &uv)
| Remarks: You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.
virtual void | textureCoord (const Vector3 &uvw)
| Remarks: You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.
virtual void | colour (const ColourValue &col)
| Add a vertex colour to a vertex.
virtual void | colour (Real r, Real g, Real b, Real a=1.0f)
| Add a vertex colour to a vertex.
virtual void | index (uint16 idx)
| Add a vertex index to construct faces / lines / points via indexing rather than just by a simple list of vertices.
virtual void | triangle (uint16 i1, uint16 i2, uint16 i3)
| Add a set of 3 vertex indices to construct a triangle; this is a shortcut to calling index() 3 times.
virtual void | quad (uint16 i1, uint16 i2, uint16 i3, uint16 i4)
| Add a set of 4 vertex indices to construct a quad (out of 2 triangles); this is a shortcut to calling index() 6 times, or triangle() twice.
virtual ManualObjectSection * | end (void)
| Finish defining the object and compile the final renderable version.
virtual void | setMaterialName (size_t subindex, const String &name)
| Alter the material for a subsection of this object after it has been specified.
virtual MeshPtr | convertToMesh (const String &meshName, const String &groupName=ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME)
| Convert this object to a Mesh.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view.
void | setBoundingBox (const AxisAlignedBox &box)
| Sets the bounding box.
ManualObjectSection * | getSection (unsigned int index) const
| Gets a pointer to a ManualObjectSection, ie a part of a ManualObject.
unsigned int | getNumSections (void) const
| Retrieves the number of ManualObjectSection objects making up this ManualObject.
const String & | getMovableType (void) const
| .
const AxisAlignedBox & | getBoundingBox (void) const
| Remarks: This bounding box is in local coordinates. .
Real | getBoundingRadius (void) const
| .
void | _updateRenderQueue (RenderQueue *queue)
| Remarks: The engine will call this method when this object is to be rendered. The object must then create one or more Renderable subclass instances which it places on the passed in Queue for rendering. .
EdgeData * | getEdgeList (void)
| Implement this method to enable stencil shadows.
bool | hasEdgeList (void)
| Overridden member from ShadowCaster.
ShadowRenderableListIterator | getShadowVolumeRenderableIterator (ShadowTechnique shadowTechnique, const Light *light, HardwareIndexBufferSharedPtr *indexBuffer, bool extrudeVertices, Real extrusionDist, unsigned long flags=0)
| Implement this method to enable stencil shadows.
virtual void | _notifyCreator (MovableObjectFactory *fact)
| Notify the object of it's creator (internal use only).
virtual MovableObjectFactory * | _getCreator (void) const
| Get the creator of this object, if any (internal use only).
virtual void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only).
virtual SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only).
virtual const String & | getName (void) const
| Returns the name of this object.
virtual Node * | getParentNode (void) const
| Returns the node to which this object is attached.
virtual SceneNode * | getParentSceneNode (void) const
| Returns the scene node to which this object is attached.
virtual void | _notifyAttached (Node *parent, bool isTagPoint=false)
| Internal method called to notify the object that it has been attached to a node.
virtual bool | isAttached (void) const
| Returns true if this object is attached to a SceneNode or TagPoint.
virtual bool | isInScene (void) const
| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.
virtual void | _notifyMoved (void)
| Internal method called to notify the object that it has been moved.
virtual void | _notifyCurrentCamera (Camera *cam)
| Internal method to notify the object of the camera to be used for the next rendering operation.
virtual const AxisAlignedBox & | getWorldBoundingBox (bool derive=false) const
| Retrieves the axis-aligned bounding box for this object in world coordinates.
virtual const Sphere & | getWorldBoundingSphere (bool derive=false) const
| Retrieves the worldspace bounding sphere for this object.
virtual void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
virtual bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component.
virtual bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not.
virtual void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
virtual Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered.
virtual void | setUserObject (UserDefinedObject *obj)
| Call this to associate your own custom user object instance with this MovableObject.
virtual UserDefinedObject * | getUserObject (void)
| Retrieves a pointer to a custom application object associated with this movable by an earlier call to setUserObject.
virtual void | setUserAny (const Any &anything)
| Sets any kind of user value on this object.
virtual const Any & | getUserAny (void) const
| Retrieves the custom user value associated with this object.
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through.
virtual uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity, see setRenderQueueGroup for full details.
virtual const Matrix4 & | _getParentNodeFullTransform (void) const
| return the full transformation of the parent sceneNode or the attachingPoint node
virtual void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
virtual void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
virtual void | removeQueryFlags (unsigned long flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
virtual uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object.
virtual void | setVisibilityFlags (uint32 flags)
| Sets the visiblity flags for this object.
virtual void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
virtual void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
virtual uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object.
virtual void | setListener (Listener *listener)
| Sets a listener for this object.
virtual Listener * | getListener (void) const
| Gets the current listener for this object.
virtual const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object.
const AxisAlignedBox & | getLightCapBounds (void) const
| Overridden member from ShadowCaster.
const AxisAlignedBox & | getDarkCapBounds (const Light &light, Real dirLightExtrusionDist) const
| Overridden member from ShadowCaster.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
bool | getCastShadows (void) const
| Returns whether shadow casting is enabled for this object.
Real | getPointExtrusionDistance (const Light *l) const
| Get the distance to extrude for a point/spot light.
virtual uint32 | getTypeFlags (void) const
| Get the 'type flags' for this MovableObject.
const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object.
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
## Static Public Member Functions
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | extrudeVertices (const HardwareVertexBufferSharedPtr &vertexBuffer, size_t originalVertexCount, const Vector4 &lightPos, Real extrudeDist)
| Utility method for extruding vertices based on a light.
## Protected Types
typedef std::map< String, StringVector > | AnimableDictionaryMap
## Protected Member Functions
virtual void | resetTempAreas (void)
| Delete temp buffers and reset init counts.
virtual void | resizeTempVertexBufferIfNeeded (size_t numVerts)
| Resize the temp vertex buffer?
virtual void | resizeTempIndexBufferIfNeeded (size_t numInds)
| Resize the temp index buffer?
virtual void | copyTempVertexToBuffer (void)
| Copy current temp vertex into buffer.
Real | getExtrusionDistance (const Vector3 &objectPos, const Light *light) const
| Helper moethod for calculating extrusion distance.
virtual void | updateEdgeListLightFacing (EdgeData *edgeData, const Vector4 &lightPos)
| Tells the caster to perform the tasks necessary to update the edge data's light listing.
virtual void | generateShadowVolume (EdgeData *edgeData, const HardwareIndexBufferSharedPtr &indexBuffer, const Light *light, ShadowRenderableList &shadowRenderables, unsigned long flags)
| Generates the indexes required to render a shadow volume into the index buffer which is passed in, and updates shadow renderables to use it.
virtual void | extrudeBounds (AxisAlignedBox &box, const Vector4 &lightPos, Real extrudeDist) const
| Utility method for extruding a bounding box.
virtual const String & | getAnimableDictionaryName (void) const
| Get the name of the animable dictionary for this class.
void | createAnimableDictionary (void) const
| Internal method for creating a dictionary of animable value names for the class, if it does not already exist.
StringVector & | _getAnimableValueNames (void)
| Get an updateable reference to animable value list.
virtual void | initialiseAnimableDictionary (StringVector &) const
| Internal method for initialising dictionary; should be implemented by subclasses wanting to expose animable parameters.
## Protected Attributes
bool | mDynamic
| Dynamic?
SectionList | mSectionList
| List of subsections.
ManualObjectSection * | mCurrentSection
| Current section.
bool | mCurrentUpdating
| Are we updating?
TempVertex | mTempVertex
| Temp storage.
bool | mFirstVertex
| First vertex indicator.
bool | mTempVertexPending
| Temp vertex data to copy?
char * | mTempVertexBuffer
| System-memory buffer whilst we establish the size required.
size_t | mTempVertexSize
| System memory allocation size, in bytes.
uint16 * | mTempIndexBuffer
| System-memory buffer whilst we establish the size required.
size_t | mTempIndexSize
| System memory allocation size, in bytes.
size_t | mDeclSize
| Current declaration vertex size.
size_t | mEstVertexCount
| Estimated vertex count.
size_t | mEstIndexCount
| Estimated index count.
ushort | mTexCoordIndex
| Current texture coordinate.
AxisAlignedBox | mAABB
| Bounding box.
Real | mRadius
| Bounding sphere.
bool | mAnyIndexed
| Any indexed geoemtry on any sections?
EdgeData * | mEdgeList
| Edge list, used if stencil shadow casting is enabled.
ShadowRenderableList | mShadowRenderables
| List of shadow renderables.
bool | mUseIdentityProjection
| Whether to use identity projection for sections.
bool | mUseIdentityView
| Whether to use identity view for sections.
String | mName
| Name of this object.
MovableObjectFactory * | mCreator
| Creator of this object (if created by a factory).
SceneManager * | mManager
| SceneManager holding this object (if applicable).
Node * | mParentNode
| node to which this object is attached
bool | mParentIsTagPoint
bool | mVisible
| Is this object visible?
Real | mUpperDistance
| Upper distance to still render.
Real | mSquaredUpperDistance
bool | mBeyondFarDistance
| Hidden because of distance?
Any | mUserAny
| User defined link to another object / value / whatever.
uint8 | mRenderQueueID
| The render queue to use when rendering this object.
bool | mRenderQueueIDSet
| Flags whether the RenderQueue's default should be used.
uint32 | mQueryFlags
| Flags determining whether this object is included / excluded from scene queries.
uint32 | mVisibilityFlags
| Flags determining whether this object is visible (compared to SceneManager mask).
AxisAlignedBox | mWorldAABB
| Cached world AABB of this object.
Sphere | mWorldBoundingSphere
AxisAlignedBox | mWorldDarkCapBounds
| World space AABB of this object's dark cap.
bool | mCastShadows
| Does this object cast shadows?
bool | mRenderingDisabled
| Does rendering this object disabled by listener?
Listener * | mListener
| MovableObject listener - only one allowed (no list) for size & performance reasons. */.
LightList | mLightList
| List of lights for this object.
ulong | mLightListUpdated
| The last frame that this light list was updated in.
## Static Protected Attributes
static uint32 | msDefaultQueryFlags
| Default query flags.
static uint32 | msDefaultVisibilityFlags
| Default visibility flags.
static AnimableDictionaryMap | msAnimableDictionary
| Static map of class name to list of animable value names.
## Classes
class | ManualObjectSection
| Built, renderable section of geometry. More...
class | ManualObjectSectionShadowRenderable
| Nested class to allow shadows. More...
struct | TempVertex
| Temporary vertex structure. More...

## Detailed Description

Class providing a much simplified interface to generating manual objects with custom geometry.

Remarks:
  Building one-off geometry objects manually usually requires getting down and dirty with the vertex buffer and vertex declaration API, which some people find a steep learning curve. This class gives you a simpler interface specifically for the purpose of building a 3D object simply and quickly. Note that if you intend to instance your object you will still need to become familiar with the Mesh class.

  This class draws heavily on the interface for OpenGL immediate-mode (glBegin, glVertex, glNormal etc), since this is generally well-liked by people. There are a couple of differences in the results though - internally this class still builds hardware buffers which can be re-used, so you can render the resulting object multiple times without re-issuing all the same commands again. Secondly, the rendering is not immediate, it is still queued just like all OGRE objects. This makes this object more efficient than the equivalent GL immediate-mode commands, so it's feasible to use it for large objects if you really want to.

  To construct some geometry with this object:
  1. If you know roughly how many vertices (and indices, if you use them) you're going to submit, call estimateVertexCount and estimateIndexCount. This is not essential but will make the process more efficient by saving memory reallocations.
  2. Call begin() to begin entering data
  3. For each vertex, call position(), normal(), textureCoord(), colour() to define your vertex data. Note that each time you call position() you start a new vertex. Note that the first vertex defines the components of the vertex - you can't add more after that. For example if you didn't call normal() in the first vertex, you cannot call it in any others. You ought to call the same combination of methods per vertex.
  4. If you want to define triangles (or lines/points) by indexing into the vertex list, you can call index() as many times as you need to define them. If you don't do this, the class will assume you want triangles drawn directly as defined by the vertex list, ie non-indexed geometry. Note that stencil shadows are only supported on indexed geometry, and that indexed geometry is a little faster; so you should try to use it.
  5. Call end() to finish entering data.
  6. Optionally repeat the begin-end cycle if you want more geometry using different rendering operation types, or different materials After calling end(), the class will organise the data for that section internally and make it ready to render with. Like any other MovableObject you should attach the object to a SceneNode to make it visible. Other aspects like the relative render order can be controlled using standard MovableObject methods like setRenderQueueGroup.

  You can also use beginUpdate() to alter the geometry later on if you wish. If you do this, you should call setDynamic(true) before your first call to begin(), and also consider using estimateVertexCount / estimateIndexCount if your geometry is going to be growing, to avoid buffer recreation during growth.

  Note that like all OGRE geometry, triangles should be specified in anti-clockwise winding order (whether you're doing it with just vertices, or using indexes too). That is to say that the front of the face is the one where the vertices are listed in anti-clockwise order.

Definition at line 101 of file OgreManualObject.h.

## Member Typedef Documentation

typedef std::map<String, StringVector> Ogre::AnimableObject::AnimableDictionaryMap`[protected, inherited]`

| Definition at line 206 of file OgreAnimable.h.

typedef std::vector<ManualObjectSection*> Ogre::ManualObject::SectionList

| Definition at line 424 of file OgreManualObject.h.

typedef std::vector<ShadowRenderable*> Ogre::ShadowCaster::ShadowRenderableList`[inherited]`

| Definition at line 127 of file OgreShadowCaster.h.

typedef VectorIterator<ShadowRenderableList> Ogre::ShadowCaster::ShadowRenderableListIterator`[inherited]`

| Definition at line 128 of file OgreShadowCaster.h.

## Constructor & Destructor Documentation

Ogre::ManualObject::ManualObject | ( | const String & | name | ) |

virtual Ogre::ManualObject::~ManualObject | ( |  | ) | `[virtual]`

## Member Function Documentation

StringVector& Ogre::AnimableObject::_getAnimableValueNames | ( | void |  | ) | `[protected, inherited]`

| Get an updateable reference to animable value list. Definition at line 232 of file OgreAnimable.h. References OGRE_EXCEPT.

virtual MovableObjectFactory* Ogre::MovableObject::_getCreator | ( | void |  | ) | const`[virtual, inherited]`

| Get the creator of this object, if any (internal use only). Definition at line 166 of file OgreMovableObject.h.

virtual SceneManager* Ogre::MovableObject::_getManager | ( | void |  | ) | const`[virtual, inherited]`

| Get the manager of this object, if any (internal use only). Definition at line 170 of file OgreMovableObject.h.

virtual const Matrix4& Ogre::MovableObject::_getParentNodeFullTransform | ( | void |  | ) | const`[virtual, inherited]`

| return the full transformation of the parent sceneNode or the attachingPoint node

virtual void Ogre::MovableObject::_notifyAttached | ( | Node * | parent,
|  | bool | isTagPoint = `false`
| ) | `[virtual, inherited]`

| Internal method called to notify the object that it has been attached to a node. Reimplemented in Ogre::Entity, Ogre::Light, and Ogre::ParticleSystem.

virtual void Ogre::MovableObject::_notifyCreator | ( | MovableObjectFactory * | fact | ) | `[virtual, inherited]`

| Notify the object of it's creator (internal use only). Definition at line 164 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::_notifyCurrentCamera | ( | Camera * | cam | ) | `[virtual, inherited]`

| Internal method to notify the object of the camera to be used for the next rendering operation. Remarks: Certain objects may want to do specific processing based on the camera position. This method notifies them incase they wish to do this. Reimplemented in Ogre::BillboardChain, Ogre::BillboardSet, Ogre::Entity, Ogre::Frustum, Ogre::InstancedGeometry::BatchInstance, Ogre::MovablePlane, Ogre::ParticleSystem, Ogre::SimpleRenderable, and Ogre::StaticGeometry::Region.

virtual void Ogre::MovableObject::_notifyManager | ( | SceneManager * | man | ) | `[virtual, inherited]`

| Notify the object of it's manager (internal use only). Definition at line 168 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::_notifyMoved | ( | void |  | ) | `[virtual, inherited]`

| Internal method called to notify the object that it has been moved. Reimplemented in Ogre::Light.

void Ogre::ManualObject::_updateRenderQueue | ( | RenderQueue * | queue | ) | `[virtual]`

| Remarks: The engine will call this method when this object is to be rendered. The object must then create one or more Renderable subclass instances which it places on the passed in Queue for rendering. . Implements Ogre::MovableObject.

virtual void Ogre::MovableObject::addQueryFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object. Definition at line 338 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::addVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object. Definition at line 366 of file OgreMovableObject.h.

virtual void Ogre::ManualObject::begin | ( | const String & | materialName,
|  | RenderOperation::OperationType | opType = `RenderOperation::OT_TRIANGLE_LIST`
| ) | `[virtual]`

  | Start defining a part of the object. Remarks: Each time you call this method, you start a new section of the object with its own material and potentially its own type of rendering operation (triangles, points or lines for example). Parameters:
  | materialName | The name of the material to render this part of the object with.
  | opType | The type of operation to use to render.

virtual void Ogre::ManualObject::beginUpdate | ( | size_t | sectionIndex | ) | `[virtual]`

  | Start the definition of an update to a part of the object. Remarks: Using this method, you can update an existing section of the object efficiently. You do not have the option of changing the operation type obviously, since it must match the one that was used before. Note: If your sections are changing size, particularly growing, use estimateVertexCount and estimateIndexCount to pre-size the buffers a little larger than the initial needs to avoid buffer reconstruction. Parameters:
  | sectionIndex | The index of the section you want to update. The first call to begin() would have created section 0, the second section 1, etc.

class virtual void Ogre::ManualObject::clear | ( | void |  | ) | `[virtual]`

| Completely clear the contents of the object. Remarks: Clearing the contents of this object and rebuilding from scratch is not the optimal way to manage dynamic vertex data, since the buffers are recreated. If you want to keep the same structure but update the content within that structure, use beginUpdate() instead of clear() begin(). However if you do want to modify the structure from time to time you can do so by clearing and re-specifying the data.

virtual void Ogre::ManualObject::colour | ( | Real | r,
|  | Real | g,
|  | Real | b,
|  | Real | a = `1.0f`
| ) | `[virtual]`

  | Add a vertex colour to a vertex. Parameters:
  | r,g,b,a | Colour components expressed as floating point numbers from 0-1

virtual void Ogre::ManualObject::colour | ( | const ColourValue & | col | ) | `[virtual]`

| Add a vertex colour to a vertex.

virtual MeshPtr Ogre::ManualObject::convertToMesh | ( | const String & | meshName,
|  | const String & | groupName = `ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME`
| ) | `[virtual]`

  | Convert this object to a Mesh. Remarks: After you've finished building this object, you may convert it to a Mesh if you want in order to be able to create many instances of it in the world (via Entity). This is optional, since this instance can be directly attached to a SceneNode itself, but of course only one instance of it can exist that way. Note: Only objects which use indexed geometry may be converted to a mesh. Parameters:
  | meshName | The name to give the mesh
  | groupName | The resource group to create the mesh in

virtual void Ogre::ManualObject::copyTempVertexToBuffer | ( | void |  | ) | `[protected, virtual]`

| Copy current temp vertex into buffer.

void Ogre::AnimableObject::createAnimableDictionary | ( | void |  | ) | const`[protected, inherited]`

| Internal method for creating a dictionary of animable value names for the class, if it does not already exist. Definition at line 219 of file OgreAnimable.h.

virtual AnimableValuePtr Ogre::AnimableObject::createAnimableValue | ( | const String & | valueName | ) | `[virtual, inherited]`

| Create a reference-counted AnimableValuePtr for the named value. Remarks: You can use the returned object to animate a value on this object, using AnimationTrack. Subclasses must override this if they wish to support animation of their values. Reimplemented in Ogre::Light. Definition at line 285 of file OgreAnimable.h. References OGRE_EXCEPT.

virtual ManualObjectSection* Ogre::ManualObject::end | ( | void |  | ) | `[virtual]`

| Finish defining the object and compile the final renderable version. Note: Will return a pointer to the finished section or NULL if the section was discarded (i.e. has zero vertices/indices).

virtual void Ogre::ManualObject::estimateIndexCount | ( | size_t | icount | ) | `[virtual]`

| Estimate the number of indices ahead of time. Remarks: Calling this helps to avoid memory reallocation when you define indices. Also very handy when using beginUpdate() to manage dynamic data - you can make the index buffer a little larger than the initial need to allow for growth later with this method.

virtual void Ogre::ManualObject::estimateVertexCount | ( | size_t | vcount | ) | `[virtual]`

| Estimate the number of vertices ahead of time. Remarks: Calling this helps to avoid memory reallocation when you define vertices. Also very handy when using beginUpdate() to manage dynamic data - you can make the vertex buffers a little larger than their initial needs to allow for growth later with this method.

virtual void Ogre::ShadowCaster::extrudeBounds | ( | AxisAlignedBox & | box,
|  | const Vector4 & | lightPos,
|  | Real | extrudeDist
| ) | const`[protected, virtual, inherited]`

  | Utility method for extruding a bounding box. Parameters:
  | box | Original bounding box, will be updated in-place
  | lightPos | 4D light position in object space, when w=0.0f this represents a directional light
  | extrudeDist | The distance to extrude

static void Ogre::ShadowCaster::extrudeVertices | ( | const HardwareVertexBufferSharedPtr & | vertexBuffer,
|  | size_t | originalVertexCount,
|  | const Vector4 & | lightPos,
|  | Real | extrudeDist
| ) | `[static, inherited]`

  | Utility method for extruding vertices based on a light. Remarks: Unfortunately, because D3D cannot handle homogenous (4D) position coordinates in the fixed-function pipeline (GL can, but we have to be cross-API), when we extrude in software we cannot extrude to infinity the way we do in the vertex program (by setting w to 0.0f). Therefore we extrude by a fixed distance, which may cause some problems with larger scenes. Luckily better hardware (ie vertex programs) can fix this. Parameters:
  | vertexBuffer | The vertex buffer containing ONLY xyz position values, which must be originalVertexCount * 2 * 3 floats long.
  | originalVertexCount | The count of the original number of vertices, ie the number in the mesh, not counting the doubling which has already been done (by VertexData::prepareForShadowVolume) to provide the extruded area of the buffer.
  | lightPos | 4D light position in object space, when w=0.0f this represents a directional light
  | extrudeDist | The distance to extrude

virtual void Ogre::ShadowCaster::generateShadowVolume | ( | EdgeData * | edgeData,
|  | const HardwareIndexBufferSharedPtr & | indexBuffer,
|  | const Light * | light,
|  | ShadowRenderableList & | shadowRenderables,
|  | unsigned long | flags
| ) | `[protected, virtual, inherited]`

  | Generates the indexes required to render a shadow volume into the index buffer which is passed in, and updates shadow renderables to use it. Parameters:
  | edgeData | The edge information to use
  | indexBuffer | The buffer into which to write data into; current contents are assumed to be discardable.
  | light | The light, mainly for type info as silhouette calculations should already have been done in updateEdgeListLightFacing
  | shadowRenderables | A list of shadow renderables which has already been constructed but will need populating with details of the index ranges to be used.
  | flags | Additional controller flags, see ShadowRenderableFlags

virtual const String& Ogre::AnimableObject::getAnimableDictionaryName | ( | void |  | ) | const`[protected, virtual, inherited]`

| Get the name of the animable dictionary for this class. Remarks: Subclasses must override this if they want to support animation of their values. Reimplemented in Ogre::Light. Definition at line 214 of file OgreAnimable.h.

const StringVector& Ogre::AnimableObject::getAnimableValueNames | ( | void |  | ) | const`[inherited]`

| Gets a list of animable value names for this object. Definition at line 260 of file OgreAnimable.h. References OGRE_EXCEPT.

const AxisAlignedBox& Ogre::ManualObject::getBoundingBox | ( | void |  | ) | const`[virtual]`

| Remarks: This bounding box is in local coordinates. . Implements Ogre::MovableObject.

Real Ogre::ManualObject::getBoundingRadius | ( | void |  | ) | const`[virtual]`

| . Implements Ogre::MovableObject.

bool Ogre::MovableObject::getCastShadows | ( | void |  | ) | const`[virtual, inherited]`

| Returns whether shadow casting is enabled for this object. Implements Ogre::ShadowCaster. Definition at line 442 of file OgreMovableObject.h.

const AxisAlignedBox& Ogre::MovableObject::getDarkCapBounds | ( | const Light & | light,
|  | Real | dirLightExtrusionDist
| ) | const`[virtual, inherited]`

| Overridden member from ShadowCaster. Implements Ogre::ShadowCaster.

static uint32 Ogre::MovableObject::getDefaultQueryFlags | ( |  | ) | `[static, inherited]`

| Get the default query flags for all future MovableObject instances. Definition at line 353 of file OgreMovableObject.h.

static uint32 Ogre::MovableObject::getDefaultVisibilityFlags | ( |  | ) | `[static, inherited]`

| Get the default visibility flags for all future MovableObject instances. Definition at line 381 of file OgreMovableObject.h.

virtual bool Ogre::ManualObject::getDynamic | ( |  | ) | const`[virtual]`

| Gets whether this object is marked as dynamic. Definition at line 156 of file OgreManualObject.h.

EdgeData* Ogre::ManualObject::getEdgeList | ( | void |  | ) | `[virtual]`

| Implement this method to enable stencil shadows. Reimplemented from Ogre::MovableObject.

Real Ogre::ShadowCaster::getExtrusionDistance | ( | const Vector3 & | objectPos,
|  | const Light * | light
| ) | const`[protected, inherited]`

| Helper moethod for calculating extrusion distance.

const AxisAlignedBox& Ogre::MovableObject::getLightCapBounds | ( | void |  | ) | const`[virtual, inherited]`

| Overridden member from ShadowCaster. Implements Ogre::ShadowCaster.

virtual Listener* Ogre::MovableObject::getListener | ( | void |  | ) | const`[virtual, inherited]`

| Gets the current listener for this object. Definition at line 392 of file OgreMovableObject.h.

const String& Ogre::ManualObject::getMovableType | ( | void |  | ) | const`[virtual]`

| . Implements Ogre::MovableObject.

virtual const String& Ogre::MovableObject::getName | ( | void |  | ) | const`[virtual, inherited]`

| Returns the name of this object. Reimplemented in Ogre::Camera. Definition at line 173 of file OgreMovableObject.h.

unsigned int Ogre::ManualObject::getNumSections | ( | void |  | ) | const

| Retrieves the number of ManualObjectSection objects making up this ManualObject.

virtual Node* Ogre::MovableObject::getParentNode | ( | void |  | ) | const`[virtual, inherited]`

| Returns the node to which this object is attached. Remarks: A MovableObject may be attached to either a SceneNode or to a TagPoint, the latter case if it's attached to a bone on an animated entity. Both are Node subclasses so this method will return either.

virtual SceneNode* Ogre::MovableObject::getParentSceneNode | ( | void |  | ) | const`[virtual, inherited]`

| Returns the scene node to which this object is attached. Remarks: A MovableObject may be attached to either a SceneNode or to a TagPoint, the latter case if it's attached to a bone on an animated entity. This method will return the scene node of the parent entity if the latter is true.

Real Ogre::MovableObject::getPointExtrusionDistance | ( | const Light * | l | ) | const`[virtual, inherited]`

| Get the distance to extrude for a point/spot light. Implements Ogre::ShadowCaster.

virtual uint32 Ogre::MovableObject::getQueryFlags | ( | void |  | ) | const`[virtual, inherited]`

| Returns the query flags relevant for this object. Definition at line 345 of file OgreMovableObject.h.

virtual Real Ogre::MovableObject::getRenderingDistance | ( | void |  | ) | const`[virtual, inherited]`

| Gets the distance at which batches are no longer rendered. Definition at line 278 of file OgreMovableObject.h.

virtual uint8 Ogre::MovableObject::getRenderQueueGroup | ( | void |  | ) | const`[virtual, inherited]`

| Gets the queue group for this entity, see setRenderQueueGroup for full details.

ManualObjectSection* Ogre::ManualObject::getSection | ( | unsigned int | index | ) | const

| Gets a pointer to a ManualObjectSection, ie a part of a ManualObject.

ShadowRenderableListIterator Ogre::ManualObject::getShadowVolumeRenderableIterator | ( | ShadowTechnique | shadowTechnique,
|  | const Light * | light,
|  | HardwareIndexBufferSharedPtr * | indexBuffer,
|  | bool | extrudeVertices,
|  | Real | extrusionDist,
|  | unsigned long | flags = `0`
| ) | `[virtual]`

| Implement this method to enable stencil shadows. Reimplemented from Ogre::MovableObject.

virtual uint32 Ogre::MovableObject::getTypeFlags | ( | void |  | ) | const`[virtual, inherited]`

| Get the 'type flags' for this MovableObject. Remarks: A type flag identifies the type of the MovableObject as a bitpattern. This is used for categorical inclusion / exclusion in SceneQuery objects. By default, this method returns all ones for objects not created by a MovableObjectFactory (hence always including them); otherwise it returns the value assigned to the MovableObjectFactory. Custom objects which don't use MovableObjectFactory will need to override this if they want to be included in queries. Reimplemented in Ogre::BillboardSet, Ogre::Entity, Ogre::Light, Ogre::ParticleSystem, and Ogre::StaticGeometry::Region.

bool Ogre::ManualObject::getUseIdentityProjection | ( | void |  | ) | const

| Returns whether or not to use an 'identity' projection. Remarks: Usually ManualObjects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normally you don't need to change this. See also: ManualObject::setUseIdentityProjection Definition at line 298 of file OgreManualObject.h.

bool Ogre::ManualObject::getUseIdentityView | ( | void |  | ) | const

| Returns whether or not to use an 'identity' view. Remarks: Usually ManualObjects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normally you don't need to change this. See also: ManualObject::setUseIdentityView Definition at line 320 of file OgreManualObject.h.

virtual const Any& Ogre::MovableObject::getUserAny | ( | void |  | ) | const`[virtual, inherited]`

| Retrieves the custom user value associated with this object. Definition at line 306 of file OgreMovableObject.h.

virtual UserDefinedObject* Ogre::MovableObject::getUserObject | ( | void |  | ) | `[virtual, inherited]`

| Retrieves a pointer to a custom application object associated with this movable by an earlier call to setUserObject. Definition at line 290 of file OgreMovableObject.h.

virtual uint32 Ogre::MovableObject::getVisibilityFlags | ( | void |  | ) | const`[virtual, inherited]`

| Returns the visibility flags relevant for this object. Definition at line 373 of file OgreMovableObject.h.

virtual bool Ogre::MovableObject::getVisible | ( | void |  | ) | const`[virtual, inherited]`

| Gets this object whether to be visible or not, if it has a renderable component. Remarks: Returns the value set by MovableObject::setVisible only.

virtual const AxisAlignedBox& Ogre::MovableObject::getWorldBoundingBox | ( | bool | derive = `false` | ) | const`[virtual, inherited]`

| Retrieves the axis-aligned bounding box for this object in world coordinates. Implements Ogre::ShadowCaster. Reimplemented in Ogre::Entity.

virtual const Sphere& Ogre::MovableObject::getWorldBoundingSphere | ( | bool | derive = `false` | ) | const`[virtual, inherited]`

| Retrieves the worldspace bounding sphere for this object. Reimplemented in Ogre::Entity.

bool Ogre::ManualObject::hasEdgeList | ( | void |  | ) | `[virtual]`

| Overridden member from ShadowCaster. Reimplemented from Ogre::MovableObject.

virtual void Ogre::ManualObject::index | ( | uint16 | idx | ) | `[virtual]`

  | Add a vertex index to construct faces / lines / points via indexing rather than just by a simple list of vertices. Remarks: You will have to call this 3 times for each face for a triangle list, or use the alternative 3-parameter version. Other operation types require different numbers of indexes, See also: RenderOperation::OperationType. Note: 32-bit indexes are not supported on all cards which is why this class only allows 16-bit indexes, for simplicity and ease of use. Parameters:
  | idx | A vertex index from 0 to 65535.

virtual void Ogre::AnimableObject::initialiseAnimableDictionary | ( | StringVector & |  | ) | const`[protected, virtual, inherited]`

| Internal method for initialising dictionary; should be implemented by subclasses wanting to expose animable parameters. Reimplemented in Ogre::Light. Definition at line 252 of file OgreAnimable.h.

virtual bool Ogre::MovableObject::isAttached | ( | void |  | ) | const`[virtual, inherited]`

| Returns true if this object is attached to a SceneNode or TagPoint.

virtual bool Ogre::MovableObject::isInScene | ( | void |  | ) | const`[virtual, inherited]`

| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.

virtual bool Ogre::MovableObject::isVisible | ( | void |  | ) | const`[virtual, inherited]`

| Returns whether or not this object is supposed to be visible or not. Remarks: Takes into account both upper rendering distance and visible flag. Reimplemented in Ogre::InstancedGeometry::BatchInstance, and Ogre::StaticGeometry::Region.

virtual void Ogre::ManualObject::normal | ( | Real | x,
|  | Real | y,
|  | Real | z
| ) | `[virtual]`

| Remarks: Vertex normals are most often used for dynamic lighting, and their components should be normalised.

virtual void Ogre::ManualObject::normal | ( | const Vector3 & | norm | ) | `[virtual]`

| Add a vertex normal to the current vertex. Remarks: Vertex normals are most often used for dynamic lighting, and their components should be normalised.

virtual void Ogre::ManualObject::position | ( | Real | x,
|  | Real | y,
|  | Real | z
| ) | `[virtual]`

| Remarks: A vertex position is slightly special among the other vertex data methods like normal() and textureCoord(), since calling it indicates the start of a new vertex. All other vertex data methods you call after this are assumed to be adding more information (like normals or texture coordinates) to the last vertex started with position().

virtual void Ogre::ManualObject::position | ( | const Vector3 & | pos | ) | `[virtual]`

| Add a vertex position, starting a new vertex at the same time. Remarks: A vertex position is slightly special among the other vertex data methods like normal() and textureCoord(), since calling it indicates the start of a new vertex. All other vertex data methods you call after this are assumed to be adding more information (like normals or texture coordinates) to the last vertex started with position().

virtual void Ogre::ManualObject::quad | ( | uint16 | i1,
|  | uint16 | i2,
|  | uint16 | i3,
|  | uint16 | i4
| ) | `[virtual]`

  | Add a set of 4 vertex indices to construct a quad (out of 2 triangles); this is a shortcut to calling index() 6 times, or triangle() twice. It's only valid for triangle list operations. Note: 32-bit indexes are not supported on all cards which is why this class only allows 16-bit indexes, for simplicity and ease of use. Parameters:
  | i1,i2,i3 | 3 vertex indices from 0 to 65535 defining a face.

virtual const LightList& Ogre::MovableObject::queryLights | ( | void |  | ) | const`[virtual, inherited]`

| Gets a list of lights, ordered relative to how close they are to this movable object. Remarks: By default, this method gives the listener a chance to populate light list first, if there is no listener or Listener::objectQueryLights returns NULL, it'll query the light list from parent entity if it is present, or returns SceneNode::findLights if it has parent scene node, otherwise it just returns an empty list. The object internally caches the light list, so it will recalculate it only when object is moved, or lights that affect the frustum have been changed ( See also: SceneManager::_getLightsDirtyCounter), but if listener exists, it will be called each time, so the listener should implement their own cache mechanism to optimise performance. This method can be useful when implementing Renderable::getLights in case the renderable is a part of the movable. Returns: The list of lights use to lighting this object.

virtual void Ogre::MovableObject::removeQueryFlags | ( | unsigned long | flags | ) | `[virtual, inherited]`

| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object. Definition at line 342 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::removeVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object. Definition at line 370 of file OgreMovableObject.h.

virtual void Ogre::ManualObject::resetTempAreas | ( | void |  | ) | `[protected, virtual]`

| Delete temp buffers and reset init counts.

virtual void Ogre::ManualObject::resizeTempIndexBufferIfNeeded | ( | size_t | numInds | ) | `[protected, virtual]`

| Resize the temp index buffer?

virtual void Ogre::ManualObject::resizeTempVertexBufferIfNeeded | ( | size_t | numVerts | ) | `[protected, virtual]`

| Resize the temp vertex buffer?

void Ogre::ManualObject::setBoundingBox | ( | const AxisAlignedBox & | box | ) |

| Sets the bounding box. Remarks: Call this after having finished creating sections to modify the bounding box. E.g. if you're using ManualObject to create 2D overlays you can call things function to set an infinite bounding box so that the object always stays visible when attached. See also: ManualObject::setUseIdentityProjection, ManualObject::setUseIdentityView, AxisAlignedBox::setInfinite Definition at line 329 of file OgreManualObject.h.

void Ogre::MovableObject::setCastShadows | ( | bool | enabled | ) | `[inherited]`

| Sets whether or not this object will cast shadows. Remarks: This setting simply allows you to turn on/off shadows for a given object. An object will not cast shadows unless the scene supports it in any case (see SceneManager::setShadowTechnique), and also the material which is in use must also have shadow casting enabled. By default all entities cast shadows. If, however, for some reason you wish to disable this for a single object then you can do so using this method. Note: This method normally refers to objects which block the light, but since Light is also a subclass of MovableObject, in that context it means whether the light causes shadows itself. Definition at line 440 of file OgreMovableObject.h.

static void Ogre::MovableObject::setDefaultQueryFlags | ( | uint32 | flags | ) | `[static, inherited]`

| Set the default query flags for all future MovableObject instances. Definition at line 349 of file OgreMovableObject.h.

static void Ogre::MovableObject::setDefaultVisibilityFlags | ( | uint32 | flags | ) | `[static, inherited]`

| Set the default visibility flags for all future MovableObject instances. Definition at line 377 of file OgreMovableObject.h.

virtual void Ogre::ManualObject::setDynamic | ( | bool | dyn | ) | `[virtual]`

| Use before defining gometry to indicate that you intend to update the geometry regularly and want the internal structure to reflect that. Definition at line 154 of file OgreManualObject.h.

virtual void Ogre::MovableObject::setListener | ( | Listener * | listener | ) | `[virtual, inherited]`

| Sets a listener for this object. Remarks: Note for size and performance reasons only one listener per object is allowed. Definition at line 388 of file OgreMovableObject.h.

virtual void Ogre::ManualObject::setMaterialName | ( | size_t | subindex,
|  | const String & | name
| ) | `[virtual]`

  | Alter the material for a subsection of this object after it has been specified. Remarks: You specify the material to use on a section of this object during the call to begin(), however if you want to change the material afterwards you can do so by calling this method. Parameters:
  | subIndex | The index of the subsection to alter
  | name | The name of the new material to use

virtual void Ogre::MovableObject::setQueryFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

| Sets the query flags for this object. Remarks: When performing a scene query, this object will be included or excluded according to flags on the object and flags on the query. This is a bitwise value, so only when a bit on these flags is set, will it be included in a query asking for that flag. The meaning of the bits is application-specific. Definition at line 334 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setRenderingDistance | ( | Real | dist | ) | `[virtual, inherited]`

  | Sets the distance at which the object is no longer rendered. Parameters:
  | dist | Distance beyond which the object will not be rendered (the default is 0, which means objects are always rendered).
Definition at line 272 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setRenderQueueGroup | ( | uint8 | queueID | ) | `[virtual, inherited]`

  | Sets the render queue group this entity will be rendered through. Remarks: Render queues are grouped to allow you to more tightly control the ordering of rendered objects. If you do not call this method, all Entity objects default to the default queue (RenderQueue::getDefaultQueueGroup), which is fine for most objects. You may want to alter this if you want this entity to always appear in front of other objects, e.g. for a 3D menu system or such. See RenderQueue for more details. Parameters:
  | queueID | Enumerated value of the queue group to use.
Reimplemented in Ogre::Entity, and Ogre::ParticleSystem.

void Ogre::ManualObject::setUseIdentityProjection | ( | bool | useIdentityProjection | ) |

| Sets whether or not to use an 'identity' projection. Remarks: Usually ManualObjects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normally you don't need to change this. The default is false. See also: ManualObject::getUseIdentityProjection

void Ogre::ManualObject::setUseIdentityView | ( | bool | useIdentityView | ) |

| Sets whether or not to use an 'identity' view. Remarks: Usually ManualObjects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normally you don't need to change this. The default is false. See also: ManualObject::getUseIdentityView

virtual void Ogre::MovableObject::setUserAny | ( | const Any & | anything | ) | `[virtual, inherited]`

| Sets any kind of user value on this object. Remarks: This method allows you to associate any user value you like with this MovableObject. This can be a pointer back to one of your own classes for instance. Note: This value is shared with setUserObject so don't use both! Definition at line 302 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setUserObject | ( | UserDefinedObject * | obj | ) | `[virtual, inherited]`

| Call this to associate your own custom user object instance with this MovableObject. Remarks: By simply making your game / application object a subclass of UserDefinedObject, you can establish a link between an OGRE instance of MovableObject and your own application classes. Call this method to establish the link. Definition at line 286 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

| Sets the visiblity flags for this object. Remarks: As well as a simple true/false value for visibility (as seen in setVisible), you can also set visiblity flags which when 'and'ed with the SceneManager's visibility mask can also make an object invisible. Definition at line 362 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setVisible | ( | bool | visible | ) | `[virtual, inherited]`

| Tells this object whether to be visible or not, if it has a renderable component. Note: An alternative approach of making an object invisible is to detach it from it's SceneNode, or to remove the SceneNode entirely. Detaching a node means that structurally the scene graph changes. Once this change has taken place, the objects / nodes that have been removed have less overhead to the visbility detection pass than simply making the object invisible, so if you do this and leave the objects out of the tree for a long time, it's faster. However, the act of detaching / reattaching nodes is in itself more expensive than setting an object visibility flag, since in the latter case structural changes are not made. Therefore, small or frequent visbility changes are best done using this method; large or more longer term changes are best done by detaching. Reimplemented in Ogre::Light.

virtual void Ogre::ManualObject::textureCoord | ( | const Vector3 & | uvw | ) | `[virtual]`

| Remarks: You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

virtual void Ogre::ManualObject::textureCoord | ( | const Vector2 & | uv | ) | `[virtual]`

| Remarks: You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

virtual void Ogre::ManualObject::textureCoord | ( | Real | u,
|  | Real | v,
|  | Real | w
| ) | `[virtual]`

| Remarks: You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

virtual void Ogre::ManualObject::textureCoord | ( | Real | u,
|  | Real | v
| ) | `[virtual]`

| Remarks: You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

virtual void Ogre::ManualObject::textureCoord | ( | Real | u | ) | `[virtual]`

| Add a texture coordinate to the current vertex. Remarks: You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

virtual void Ogre::ManualObject::triangle | ( | uint16 | i1,
|  | uint16 | i2,
|  | uint16 | i3
| ) | `[virtual]`

  | Add a set of 3 vertex indices to construct a triangle; this is a shortcut to calling index() 3 times. It is only valid for triangle lists. Note: 32-bit indexes are not supported on all cards which is why this class only allows 16-bit indexes, for simplicity and ease of use. Parameters:
  | i1,i2,i3 | 3 vertex indices from 0 to 65535 defining a face.

virtual void Ogre::ShadowCaster::updateEdgeListLightFacing | ( | EdgeData * | edgeData,
|  | const Vector4 & | lightPos
| ) | `[protected, virtual, inherited]`

  | Tells the caster to perform the tasks necessary to update the edge data's light listing. Can be overridden if the subclass needs to do additional things. Parameters:
  | edgeData | The edge information to update
  | lightPos | 4D vector representing the light, a directional light has w=0.0

## Member Data Documentation

AxisAlignedBox Ogre::ManualObject::mAABB`[protected]`

| Bounding box. Definition at line 467 of file OgreManualObject.h.

bool Ogre::ManualObject::mAnyIndexed`[protected]`

| Any indexed geoemtry on any sections? Definition at line 471 of file OgreManualObject.h.

bool Ogre::MovableObject::mBeyondFarDistance`[protected, inherited]`

| Hidden because of distance? Definition at line 115 of file OgreMovableObject.h.

bool Ogre::MovableObject::mCastShadows`[protected, inherited]`

| Does this object cast shadows? Definition at line 133 of file OgreMovableObject.h.

MovableObjectFactory* Ogre::MovableObject::mCreator`[protected, inherited]`

| Creator of this object (if created by a factory). Definition at line 103 of file OgreMovableObject.h.

ManualObjectSection* Ogre::ManualObject::mCurrentSection`[protected]`

| Current section. Definition at line 432 of file OgreManualObject.h.

bool Ogre::ManualObject::mCurrentUpdating`[protected]`

| Are we updating? Definition at line 434 of file OgreManualObject.h.

size_t Ogre::ManualObject::mDeclSize`[protected]`

| Current declaration vertex size. Definition at line 459 of file OgreManualObject.h.

bool Ogre::ManualObject::mDynamic`[protected]`

| Dynamic? Definition at line 428 of file OgreManualObject.h.

EdgeData* Ogre::ManualObject::mEdgeList`[protected]`

| Edge list, used if stencil shadow casting is enabled. Definition at line 473 of file OgreManualObject.h.

size_t Ogre::ManualObject::mEstIndexCount`[protected]`

| Estimated index count. Definition at line 463 of file OgreManualObject.h.

size_t Ogre::ManualObject::mEstVertexCount`[protected]`

| Estimated vertex count. Definition at line 461 of file OgreManualObject.h.

bool Ogre::ManualObject::mFirstVertex`[protected]`

| First vertex indicator. Definition at line 447 of file OgreManualObject.h.

LightList Ogre::MovableObject::mLightList`[mutable, protected, inherited]`

| List of lights for this object. Reimplemented in Ogre::StaticGeometry::Region. Definition at line 141 of file OgreMovableObject.h.

ulong Ogre::MovableObject::mLightListUpdated`[mutable, protected, inherited]`

| The last frame that this light list was updated in. Reimplemented in Ogre::StaticGeometry::Region. Definition at line 143 of file OgreMovableObject.h.

Listener* Ogre::MovableObject::mListener`[protected, inherited]`

| MovableObject listener - only one allowed (no list) for size & performance reasons. */. Definition at line 138 of file OgreMovableObject.h.

SceneManager* Ogre::MovableObject::mManager`[protected, inherited]`

| SceneManager holding this object (if applicable). Definition at line 105 of file OgreMovableObject.h.

String Ogre::MovableObject::mName`[protected, inherited]`

| Name of this object. Reimplemented in Ogre::Camera. Definition at line 101 of file OgreMovableObject.h.

bool Ogre::MovableObject::mParentIsTagPoint`[protected, inherited]`

| Definition at line 108 of file OgreMovableObject.h.

Node* Ogre::MovableObject::mParentNode`[protected, inherited]`

| node to which this object is attached Definition at line 107 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::mQueryFlags`[protected, inherited]`

| Flags determining whether this object is included / excluded from scene queries. Definition at line 123 of file OgreMovableObject.h.

Real Ogre::ManualObject::mRadius`[protected]`

| Bounding sphere. Definition at line 469 of file OgreManualObject.h.

bool Ogre::MovableObject::mRenderingDisabled`[protected, inherited]`

| Does rendering this object disabled by listener? Definition at line 136 of file OgreMovableObject.h.

uint8 Ogre::MovableObject::mRenderQueueID`[protected, inherited]`

| The render queue to use when rendering this object. Definition at line 119 of file OgreMovableObject.h.

bool Ogre::MovableObject::mRenderQueueIDSet`[protected, inherited]`

| Flags whether the RenderQueue's default should be used. Definition at line 121 of file OgreMovableObject.h.

AnimableDictionaryMap Ogre::AnimableObject::msAnimableDictionary`[static, protected, inherited]`

| Static map of class name to list of animable value names. Definition at line 208 of file OgreAnimable.h.

uint32 Ogre::MovableObject::msDefaultQueryFlags`[static, protected, inherited]`

| Default query flags. Definition at line 147 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::msDefaultVisibilityFlags`[static, protected, inherited]`

| Default visibility flags. Definition at line 149 of file OgreMovableObject.h.

SectionList Ogre::ManualObject::mSectionList`[protected]`

| List of subsections. Definition at line 430 of file OgreManualObject.h.

ShadowRenderableList Ogre::ManualObject::mShadowRenderables`[protected]`

| List of shadow renderables. Definition at line 475 of file OgreManualObject.h.

Real Ogre::MovableObject::mSquaredUpperDistance`[protected, inherited]`

| Definition at line 113 of file OgreMovableObject.h.

uint16* Ogre::ManualObject::mTempIndexBuffer`[protected]`

| System-memory buffer whilst we establish the size required. Definition at line 455 of file OgreManualObject.h.

size_t Ogre::ManualObject::mTempIndexSize`[protected]`

| System memory allocation size, in bytes. Definition at line 457 of file OgreManualObject.h.

TempVertex Ogre::ManualObject::mTempVertex`[protected]`

| Temp storage. Definition at line 445 of file OgreManualObject.h.

char* Ogre::ManualObject::mTempVertexBuffer`[protected]`

| System-memory buffer whilst we establish the size required. Definition at line 451 of file OgreManualObject.h.

bool Ogre::ManualObject::mTempVertexPending`[protected]`

| Temp vertex data to copy? Definition at line 449 of file OgreManualObject.h.

size_t Ogre::ManualObject::mTempVertexSize`[protected]`

| System memory allocation size, in bytes. Definition at line 453 of file OgreManualObject.h.

ushort Ogre::ManualObject::mTexCoordIndex`[protected]`

| Current texture coordinate. Definition at line 465 of file OgreManualObject.h.

Real Ogre::MovableObject::mUpperDistance`[protected, inherited]`

| Upper distance to still render. Definition at line 112 of file OgreMovableObject.h.

bool Ogre::ManualObject::mUseIdentityProjection`[protected]`

| Whether to use identity projection for sections. Definition at line 477 of file OgreManualObject.h.

bool Ogre::ManualObject::mUseIdentityView`[protected]`

| Whether to use identity view for sections. Definition at line 479 of file OgreManualObject.h.

Any Ogre::MovableObject::mUserAny`[protected, inherited]`

| User defined link to another object / value / whatever. Definition at line 117 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::mVisibilityFlags`[protected, inherited]`

| Flags determining whether this object is visible (compared to SceneManager mask). Definition at line 125 of file OgreMovableObject.h.

bool Ogre::MovableObject::mVisible`[protected, inherited]`

| Is this object visible? Definition at line 110 of file OgreMovableObject.h.

AxisAlignedBox Ogre::MovableObject::mWorldAABB`[mutable, protected, inherited]`

| Cached world AABB of this object. Reimplemented in Ogre::ParticleSystem. Definition at line 127 of file OgreMovableObject.h.

Sphere Ogre::MovableObject::mWorldBoundingSphere`[mutable, protected, inherited]`

| Definition at line 129 of file OgreMovableObject.h.

AxisAlignedBox Ogre::MovableObject::mWorldDarkCapBounds`[mutable, protected, inherited]`

| World space AABB of this object's dark cap. Definition at line 131 of file OgreMovableObject.h.

The documentation for this class was generated from the following file:

- OgreManualObject.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:47:02 2008